<?php
include_once('RafflePlayWoo_InstallIndicator.php');
include_once('RafflePlayWoo_Raffles.php');
include_once('w/W_RafflePlayWoo_MainPage.php');
include_once('w/W_RafflePlayWoo_ViewPage.php');
include_once('w/W_RafflePlayWoo_AuditPage.php');
include_once('w/W_RafflePlayWoo_Reports.php');
include_once('w/W_RafflePlayWoo_Info.php');
include_once('w/W_RafflePlayWoo_Raffles.php');
include_once('w/W_RafflePlayWoo_Winners.php');
include_once('d/D_RafflePlayWoo_Main.php');
include_once('d/D_RafflePlayWoo_Reports.php');

class RafflePlayWoo_LifeCycle extends RafflePlayWoo_InstallIndicator{
    private $db_obj     = null; 
    private $db_report  = null;
    private $db_raffle  = null;
    private $default_raffle = null;
    const COUNT_STARTS_AT_TXT = 'ticket_count_starts_at'; 
    const LIVE_RAFFLE_TXT     = 'live_raffle'; 
    const PRODUCT_CKB         = '_rpwoo_ckb';
    const PRODUCT_NO_NAME     = '_rpwoo_ticket_no';
    const RAFFLE_TYPE         = '_rpwoo_raffle_type';
    const DEFAULT_RAFFLE_ID   = 0;
    const DEFAULT_RAFFLE_SHORT = "[raffle name='msg' id='0']";
    const PRODUCTION_PLUGIN   = true;

    public function __construct(){
        $this->db_obj    = new RafflePlayWoo_MainTbl();
        $this->db_report = new RafflePlayWoo_Reports();
        $this->db_raffle = new RafflePlayWoo_RaffleTbl();
        $this->default_raffle = null;
    }

    public function install(){
        
        // Initialize Plugin Options
        $this->initOptions();

        // Initialize DB Tables used by the plugin
        $this->installDatabaseTables();

        // Other Plugin initialization - for the plugin writer to override as needed
        $this->otherInstall();

        // Record the installed version
        $this->saveInstalledVersion();

        // To avoid running install() more then once
        $this->markAsInstalled();
    }

    public function uninstall(){
        $this->otherUninstall();
        $this->unInstallDatabaseTables();
        $this->deleteSavedOptions();
        $this->markAsUnInstalled();
    }

    public function upgrade() {
    }

    public function activate() {
    }

    public function deactivate(){        
    }

    protected function initOptions() {
    }


    protected function installDatabaseTables() {
    }


    protected function unInstallDatabaseTables() {
    }


    protected function otherInstall() {
    }

  
    protected function otherUninstall() {
    }

    public function addMenuPages() {
        $this->addRaffleMainPage();       
        $this->addRaffleViewPage(); 
        $this->addRaffleProductPage();
        $this->addRaffleWinnersPage();   
        $this->addRaffleReportsPage(); 
        $this->addRaffleInstructionsPage();                     
    }
    
    protected function requireExtraPluginFiles() { 
        require_once(ABSPATH . 'wp-admin/includes/plugin.php');
    }

 
    protected function getPluginSlug() {
        return get_class($this) . '_raffle_play_woo';
    }

    protected function getPluginViewSlug(){
        return get_class($this) . '_raffle_play_view';
    }

    protected function getPluginAuditSlug(){
        return get_class( $this ) . '_raffle_play_audit';
    }

    protected function getPluginReportsSlug(){
        return get_class( $this ) . '_raffle_play_reports';
    }

    protected function getPluginInfoSlug(){
        return get_class( $this ) . '_raffle_play_info';
    }
    
    protected function getPluginRaffleProductSlug(){
        return get_class( $this ) . '_raffle_play_product';
    }

    protected function getPluginWinnersSlug(){
        return get_class( $this ) . '_raffle_play_winners';
    }


    protected function addRaffleMainPage(){
        global $rpwoo_main_page;   
        $displayName = $this->getPluginDisplayName(); 

        $rpwoo_main_page = add_menu_page(   $displayName,
                                            $displayName,
                                            'manage_options',
                                            $this->getPluginSlug(),
                                            array( &$this, 'drp_settings'),
                                            (RAFFLE_PLAY_WOO_URL.'/images/icons/plugin-icon.png'),
                                            150
                        );
    }

    protected function addRaffleProductPage(){

        global $rpwoo_product_page;

        $displayName = esc_html__('Raffles', RAFFLE_PLAY_WOO_DOMAIN );  

        $rpwoo_product_page = add_submenu_page( $this->getPluginSlug(),
                                          $displayName,
                                          $displayName,
                                          'manage_options',
                                          $this->getPluginRaffleProductSlug(),
                                          array( &$this, 'drp_raffles_page'),
                                          171 
                        );
    }

    protected function addRaffleViewPage(){
        global $rpwoo_view_page;
        $displayName = esc_html__('View Tickets', RAFFLE_PLAY_WOO_DOMAIN );  

        $rpwoo_view_page = add_submenu_page( $this->getPluginSlug(),
                                          $displayName,
                                          $displayName,
                                          'manage_options',
                                          $this->getPluginViewSlug(),
                                          array( &$this, 'drp_view_page'),
                                          161 
                        );
    }

    protected function addRaffleWinnersPage(){
        global $rpwoo_winners_page;
        $displayName = esc_html__('Winners', RAFFLE_PLAY_WOO_DOMAIN );  

        $rpwoo_winners_page = add_submenu_page( $this->getPluginSlug(),
                                          $displayName,
                                          $displayName,
                                          'manage_options',
                                          $this->getPluginWinnersSlug(),
                                          array( &$this, 'drp_winners_page'),
                                          175
                        );
    }

    public function addRaffleReportsPage() {
        global $rpwoo_reports_page;   
        $displayName = esc_html__('Reports', RAFFLE_PLAY_WOO_DOMAIN );   

        $rpwoo_reports_page = add_submenu_page( 
                                            $this->getPluginSlug(),
                                            $displayName,
                                            $displayName,
                                            'manage_options',
                                            $this->getPluginReportsSlug(),
                                            array( &$this, 'drp_reports_page'),                                          
                                            201
                        );                  
    }

    public function addRaffleInstructionsPage() {
        global $rpwoo_info_page;   
        $displayName = esc_html__('Documentation', RAFFLE_PLAY_WOO_DOMAIN );   

        $rpwoo_info_page = add_submenu_page( 
                                            $this->getPluginSlug(),
                                            $displayName,
                                            $displayName,
                                            'manage_options',
                                            $this->getPluginInfoSlug(),
                                            array( &$this, 'drp_info_page'),                                          
                                            205
                        );                  
    }

    protected function addRaffleAuditPage(){
        global $rpwoo_audit_page;
        $displayName = esc_html__('Audit', RAFFLE_PLAY_WOO_DOMAIN );  

        $rpwoo_audit_page = add_submenu_page( $this->getPluginSlug(),
                                          $displayName,
                                          $displayName,
                                          'manage_options',
                                          $this->getPluginAuditSlug(),
                                          array( &$this, 'drp_audit_page'),
                                          122 
                        );
    }
    

    protected function prefixTableName($name) {
        global $wpdb;
        return $wpdb->prefix .  strtolower($this->prefix($name));
    }

    public function drp_woo_plugin_links($links, $file ){
        $plugin_basename = 'raffle-play-woo/raffle-play-woo.php';

        if( $plugin_basename == $file )
            return array_merge( $links,                
                    array( '<a href="' . menu_page_url( $this->getPluginInfoSlug(), false ) .'">' . __('Installation Info', RAFFLE_PLAY_WOO_DOMAIN ) . '</a>' )
                ); 
        else
            return $links;
    }


    private function drp_loadDefaultRaffle( $load_extra = 1 ){

        if( $this->default_raffle !== null )        
            return $this->default_raffle;

        $raffle_name = $this->get_raffle_name();

        $is_raffle_terminated = $this->isRaffleTerminated();
        $is_raffle_limited    = $this->isRaffleLimited();

        $this->default_raffle = new RafflePlayWoo_RaffleProduct(); 
        $this->default_raffle->set_id( 0 );
        $this->default_raffle->set_name( $raffle_name );
        $this->default_raffle->set_is_terminated( $this->isRaffleTerminated() );
        $this->default_raffle->set_is_live( $this->isLiveRaffle() );
        $this->default_raffle->set_is_limit( $this->isRaffleLimited() );
        $this->default_raffle->set_limit_no( $this->getLimitNo() );
        $this->default_raffle->set_prefix( $this->getTicketPrefix() );
        $this->default_raffle->set_start_datetime( 
                $this->getStartDate(), $this->getStartTime() );
        $this->default_raffle->set_end_datetime(
                $this->getEndDate(), $this->getEndTime() );
        $this->default_raffle->set_last_purchased( $this->getLastTicketNo( $this->default_raffle->get_is_live() ) );
        $this->default_raffle->set_test_ticket( $this->getLastTicketNo( false ) );

    }

    private function getExtraInfo(){

        $result = array(
            'email_line_one' => $this->getEmailHeaderLbl(),
            'email_line_two'  => $this->getEmailBodyLbl(),
            'email_pos'      => intval( $this->getEmailPos() ),
            'msg_terminated' => '',
            'msg_not_started' => $this->get_msg_start(),
            'msg_has_ended'   => $this->get_msg_end(),
            'msg_none_left'   => $this->get_msg_add_to_cart(),
            'msg_add_ex'      => $this->get_add_to_cart_ex(),
            'msg_update_ex'   => $this->get_update_cart_ex(),
            'msg_will_enddate'=> $this->get_msg_will_enddate(),
            'wp_date_format'  => get_option( 'date_format' ),
            'wp_time_format'  => get_option( 'time_format' ),
            'inc_name'        => $this->get_inc_name()            
        );

        return $result;
    }

    private function drp_loadRaffleById( $raffle_id, $load_extra = 0 ){
        //load non default raffle
        $raffle_obj = null;
      

        if( $raffle_id == 0 ){

            $this->drp_loadDefaultRaffle( $load_extra );
            $raffle_obj = $this->default_raffle;

        }

        return $raffle_obj;
    }

    private function drp_show_ticket_sq( $order_id, $type ){

        $rec_data       = $this->db_obj->getTicketsFromOrder( $order_id );   

        if( count( $rec_data ) == 0 ){
            return;
        }
        
        $ticket_prefix      = trim( $this->getTicketPrefix() );
        $email_header       = trim( $this->getEmailHeaderLbl() );
        $email_body         = trim( $this->getEmailBodyLbl() );
        $def_raffle_name    = $this->get_raffle_name();
        $inc_raffle_name    = $this->get_inc_name();    
       
        $header             = "<section class='woocommerce-order-details'>";

        if( $email_header !== '' )
            $header .= "<h2 class='woocommerce-order-details__title'>".esc_html( $email_header )."</h2>";

        $table_margin_bottom = '40px';
    

        $info_data = array();      
     
        foreach( $rec_data as $item ){
            $raffle_id = $item->raffle;     

            if( $item->raffle == 0  ){
                if( ! isset( $info_data[ $def_raffle_name] ) ){
                    $info_data[ $def_raffle_name]['tickets'] = array();
                }
                $ticket_no = $ticket_prefix . $item->ticket;
                array_push( $info_data[ $def_raffle_name ]['tickets'], $ticket_no );               
            }
        }
            

        
        if( $type == 'admin'){

            $header = "<h3 class='form-field form-field-wide'>".esc_html( $email_header )."</h3>";  
            $table_margin_bottom = '0px';

        }
       
        if( sizeof( $info_data ) > 0 ){
            echo $header;  
            
            $col_span = 1;
            if( $inc_raffle_name )
                $col_span += 1;
            if( $email_body != '' )
                $col_span += 1;

        ?>
            
            <table style="width: 100%; margin-bottom: <?php echo $table_margin_bottom;?>; margin-left: -1px; font-weight: 600;" class="shop_table shop_table_responsive additional_info">
                <tbody>
                 
                        <?php 
                                foreach( $info_data as $raffle=>$tickets_row ){
                                    $tickets_str = '';
                                    $extra_row_email = '';
                                    if( is_array( $tickets_row['tickets'] )){
                                        $tickets_str = implode( ', ', $tickets_row['tickets'] );
                                    }                                   

                                echo '<tr>';
                            ?>
                            
                            <?php if( $inc_raffle_name ) { ?>
                                <th style="font-weight: 600; color:#636363;border:1px solid #e5e5e5;vertical-align:middle;padding:12px;text-align:left;"><?php
                                    echo esc_html( $raffle ) ; ?>
                                </th>
                            <?php } ?>

                            <?php if( $email_body != '' ){ ?>
                                <th style="font-weight: 600; color:#636363;border:1px solid #e5e5e5;vertical-align:middle;padding:12px;text-align:left;"><?php echo esc_html( $email_body) ; ?></th>
                            <?php } ?>  

                            <td style="color:#636363;border:1px solid #e5e5e5;vertical-align:middle;padding:12px;text-align:left" > <?php echo $tickets_str; ?> </td>                          

                        <?php 
                            echo '</tr>';
                                if( $extra_row_email !== '' ){ ?>
                                    <tr>                             
                                        <td style="color:#636363;border:1px solid #e5e5e5;vertical-align:middle;padding:12px;text-align:center;" colspan='<?php echo $col_span; ?>'> 
                                        <?php echo esc_html( $extra_row_email ); ?> </td>                                                       
                                    </tr>  

                           <?php
                                }
                                
                            } 
                                                    
                            ?>   
                   
                </tbody>
            </table>
     
        <?php
            if( $type !== 'admin')
              echo '</section>';
        }
    }

    public function drp_display_order_data_in_admin( $order ){        
        $this->drp_show_ticket_sq( $order->get_id(), 'admin' );
    }

    public function drp_product_column_raffle( $column, $postid ) {        
        if( $column == 'raffle_column'){
            $product_obj = wc_get_product( $postid );
            if( $product_obj == null )
                return;

            $product_meta =  get_post_meta( $postid );
            $is_raffle = $product_obj->get_meta( self::PRODUCT_CKB, true ) == 'yes';
            if( $is_raffle ){

                try {

                    $raffle_ticket_no = $product_obj->get_meta( self::PRODUCT_NO_NAME , true ) ;  

                    $default_raffle_name = $this->get_raffle_name(); 

                    if( $this->isRaffleTerminated() )
                        $default_raffle_name .= ' (T)';

                    $raffle_name = $this->db_raffle->raffleNamebyProduct( $default_raffle_name, $postid );
                    echo  "<span style='position: relative; top: -7px;' class='row-title'><b>". $raffle_ticket_no .
                        "</b><img style='position: relative; top:8px;' src='".RAFFLE_PLAY_WOO_URL."/images/icons/plugin-icon.png' alt='raffle' /> - " . $raffle_name . " </span>";  
                                        
                } catch (\Throwable $th) {
                    error_log('Issues displaying the raffle names in columns');
                }

            }else{
                echo ' ';
            }
        }   
    }


    public function drp_woo_mark_deleted_order( $order_id ){       

        $order_exists = $this->db_obj->orderExists( $order_id );

        if( $order_exists ){
            //mark as deleted
            $order_exists = $this->db_obj->markOrderAsDeleted( $order_id );
        }else{
            // no action required
        }
    }

    public function drp_add_product_column( $columns ) {

        try {
            $raffle_column = array( 'raffle_column' => __( 'Raffle', RAFFLE_PLAY_WOO_DOMAIN ) ); 
            array_splice( $columns, 2, 0, $raffle_column );   
        } catch (\Throwable $th) {
            //throw $th;
        }
  
        return $columns;
    }

    
    public function drp_order_email_instructions( $order, $sent_to_admin, $plain_text, $email ) {
        $sent_to_admin = false; 
        $order_id = $order->get_id();    
        $this->drp_show_ticket_sq( $order_id, 'email');
    }

    public function drp_order_email_instructions_after_customer(  $order, $sent_to_admin, $plain_text ){
        $sent_to_admin = false; 
        $order_id = $order->get_id();    
        $this->drp_show_ticket_sq( $order_id, 'email');
    }

    public function drp_display_order_data( $order_id ){  
        $this->drp_show_ticket_sq( $order_id, 'admin');
    }   

    public function drp_display_order_data_thank_you( $order_id ){
        $this->drp_show_ticket_sq( $order_id, 'thank');
    }

    private function drp_getDefaultRaffleProducts(){
   
        $products = array();

        $wp_products = wc_get_products(array(
            'limit'  => -1,
            'status' => 'publish',
        ));
       

        foreach( $wp_products as $prod ){
            $prod_id = $prod->get_id();            
            $is_default_raffle = get_post_meta( $prod_id, self::PRODUCT_CKB, true );
            $raffle_type = get_post_meta( $prod_id, self::RAFFLE_TYPE, true );
            if( $is_default_raffle == 'yes'){
                $raffle_type = get_post_meta( $prod_id, self::RAFFLE_TYPE, true );
                if( ($raffle_type == false ) || ($raffle_type == '0') )
                    array_push( $products,  $prod->get_title() );
            }
        }

        return $products;

    }
    

    private function drp_woo_process_order( $order_id ){ 

        $order_raffle_exists = $this->db_obj->orderExists( $order_id );
        if( $order_raffle_exists ){  
            //no point moving ahead, the order has being assigned raffle numbers already 
            //if deleted, make it live, as the order status, is either processing, or completed
            $this->db_obj->markOrderAsNotDeleted( $order_id );        
            return;
        }
    
        try {
            $order = wc_get_order( $order_id );
            $items = $order->get_items();
                        
            $total_tickets_purchased = 0;
            $total_price = 0;
            $found_products = false;     
    
            $customer_id = $order->get_customer_id();
            
            $order_status = $order->get_status();
        } catch (\Throwable $th) {
            $items = array();
            error_log('Could not load order data');
        }


        //process the products from the order
        $last_ticket_no = '';
        foreach( $items as $item ){
            $product_id = intval( $item['product_id'] );
            if( $product_id > -1 ){
                              
                $product_obj = wc_get_product( $product_id ); 
                
                if( $product_obj == null )
                    continue;

                $is_raffle_product = $product_obj->get_meta( self::PRODUCT_CKB, true ) == 'yes';                            

                if( $is_raffle_product ){   

                    $raffle_product_no = $product_obj->get_meta( self::PRODUCT_NO_NAME, true );     
                    //get the number of tickets from the products, and the number of products                 
                    $raffle_id = 0;  //default raffle
                    $raffle_obj = null;
                    $raffle_type = $product_obj->get_meta( self::RAFFLE_TYPE, true ); 

                    if( $raffle_type != '' ){     
                        $raffle_id = intval( $raffle_type );                       
                    }

                    //get raffle object
                    
                    $raffle_obj = $this->drp_loadRaffleById( $raffle_id );                 

                    //for multiple product raffle, the last raffle number needs to be taken from the table - raffle_products
                    $last_ticket_no =  $raffle_obj->get_last_purchased(); 
                    $tmp_last_ticket_no = $last_ticket_no + 1;

                    $no_of_tickets_product  = intval( $raffle_product_no );                  

                    if( $no_of_tickets_product > 0){
                        
                        $found_products = true;
                        $product = wc_get_product( $product_id );
                        $product_name = $product->get_title();
                        $product_price = $product->get_price();                    
                        
                        $purchased_quantity    = intval( $item['quantity'] );

                        $total_tickets_purchased += $no_of_tickets_product * $purchased_quantity;
                        $total_price             += floatval( $item['line_total'] );
                        $tickets_purchased       = $no_of_tickets_product * $purchased_quantity;

                        $is_live = $raffle_obj->is_live() ? 1 : 0;

                        $price_total = $product_price * $purchased_quantity;
                                                
                        //catid_one used as raffle type
                        $record_main = array(
                            'orderid'       => $order_id,
                            'customerid'    => $customer_id,
                            'productid'     => $product_id,
                            'quantity'      => $purchased_quantity,                           
                            'ticketspurchased' => $tickets_purchased,
                            'ticketno'      => 0,
                            'ticketfrom'    => $last_ticket_no + 1,
                            'ticketto'      => 0,
                            'totalprice'    => $price_total,
                            'tickettxt'     => '',
                            'liveorder'     => $is_live,
                            'order_status'  => '',
                            'ticket'        => 0,
                            'catid_one'     => $raffle_id 
                        );                       
                                                                       
                        $product_tickets = $tmp_last_ticket_no + ( $tickets_purchased - 1 );
                      
                        while( $tmp_last_ticket_no <= $product_tickets ){
                            $record_main['ticket'] = $tmp_last_ticket_no;
                            $exec_sql = $this->db_obj->insertNewRecMain( $record_main ); 
                            $tmp_last_ticket_no += 1; 
                        }
                        
                    }
                    
                }
            }
        }

    }

    function admin_bar_item ( WP_Admin_Bar $admin_bar ) {
        if ( ! current_user_can( 'manage_options' ) ) {
            return;
        }
        
        $admin_bar->add_menu( array(
            'id'    => 'menu-id-raffle-dan',
            'parent' => null,
            'group'  => null,
            'title' => __('Raffle Play Woo', RAFFLE_PLAY_WOO_DOMAIN ), //you can use img tag with image link. it will show the image icon Instead of the title.
            'href'  => '#',
            'meta' => [
                'title' => __( 'Raffle', RAFFLE_PLAY_WOO_DOMAIN ), //This title will show on hover
            ]
        ) );       
    }

    public function drp_woo_process_checkout( $order_id){
        $this->drp_woo_process_order( $order_id );              
    }

    public function drp_woo_save_custom_fields( $post_id ){    
        
        $product = wc_get_product( $post_id );
        $custom_field_ckb = '';
        $raffle_type = 0;

        if( isset( $_POST[ self::PRODUCT_CKB ] ) ){
            $custom_field_ckb =  $_POST[ self::PRODUCT_CKB ];           
        }                                         

        $product->update_meta_data( self::PRODUCT_CKB , esc_attr( $custom_field_ckb ) );                    
     
      
        if( isset( $_POST[ self::PRODUCT_NO_NAME ] )  ){
            $custom_field_ticket_no = (int) $_POST[ self::PRODUCT_NO_NAME ];        
            $product->update_meta_data( self::PRODUCT_NO_NAME, esc_attr( $custom_field_ticket_no ) );
           
        }
        if( isset( $_POST[ self::RAFFLE_TYPE ] )  ){
            $raffle_type =  isset( $_POST[ self::RAFFLE_TYPE ] ) ?  $_POST[ self::RAFFLE_TYPE ] : '0';
            $product->update_meta_data( self::RAFFLE_TYPE , esc_attr( $raffle_type ) );
        }

        $product->save(); 
        
        //update raffle product
        $this->db_raffle->deleteProductRaffle( $post_id );
        if( $custom_field_ckb !== '' ){
            $this->db_raffle->insertProductRaffle( $raffle_type, $post_id );
        }
    }

    private function drp_get_main_settings(){
        $settings = [
            'raffle_name'               => $this->get_raffle_name(),
            self::COUNT_STARTS_AT_TXT   => $this->getCountStartsAt(),
            'started_orders'            => $this->hasStartedOrders(),
            'live_raffle'               => $this->isLiveRaffle(),
            'live_last_ticket'          => $this->db_raffle->getLastSoldTicket( 0 ), // $this->getLastTicketNo( true ),
            'test_start_ticket'         => $this->getDefaultDebugNo(),
            'test_last_ticket'          => $this->getLastTicketNo( false ),
            'ticket_prefix'             => $this->getTicketPrefix(),
            'end_date'                  => $this->getEndDate(),
            'end_time'                  => $this->getEndTime(),
            'email_header_lbl'          => $this->getEmailHeaderLbl(),
            'email_body_lbl'            => $this->getEmailBodyLbl(),         
            'db_health'                 => $this->isTablesCreated(),
            'is_limited'                => $this->isRaffleLimited(),
            'limit_no'                  => '',
            'start_date'                => '',
            'end_date'                  => '',
            'start_time'                => '',
            'end_time'                  => '',
            'email_extra'               => '',
            'email_pos'                 => $this->getEmailPos(),
            'terminated'                => $this->isRaffleTerminated(),          
            'live_tickets_purchased'    => $this->db_obj->getNoTicketRaffle( true, 0 ),
            'test_tickets_purchased'    => $this->db_obj->getNoTestTickets(),                     
            'msg_shortcode'             => self::DEFAULT_RAFFLE_SHORT,
            'products'                  => $this->drp_getDefaultRaffleProducts(),
            'inc_raffle_name'           => $this->get_inc_name(),
            'limit_order_per_raffle'    => false,
            'limit_order_per_raffle_txt'=> '',
            'msg_will_enddate'          => ''
        ];

        return $settings;

    }

    public function drp_woo_product_checkbox(){
        $checkbox_raffle = array(
            'label' => __('Raffle Play Product', RAFFLE_PLAY_WOO_DOMAIN), // Text in Label
            'class' => '',
            'style' => '',
            'wrapper_class' => '',       
            'id' => self::PRODUCT_CKB, 
            'name' => self::PRODUCT_CKB,     
            'desc_tip' => '',
            'custom_attributes' => '', 
            'description' => ''
          );

        $no_of_tickets =array( 
            'id'                => self::PRODUCT_NO_NAME, 
            'name'              => self::PRODUCT_NO_NAME,
            'label'             => __( 'Raffle Number of tickets', RAFFLE_PLAY_WOO_DOMAIN ), 
            'placeholder'       => '', 
            'description'       => __( '', RAFFLE_PLAY_WOO_DOMAIN ),
            'type'              => 'number',             
            'custom_attributes' => array(
                    'step' 	=> 'any',
                    'min'	=> '0'
                ) 
        );

     
        $raffles = $this->get_simple_raffles();

        $raffle_type = array(
            'id'            => self::RAFFLE_TYPE,
            'name'          => self::RAFFLE_TYPE,
            'label'         => __( 'Raffle', RAFFLE_PLAY_WOO_DOMAIN ), 
            'options'       => $raffles                                
        );
          
        woocommerce_wp_checkbox( $checkbox_raffle ); 
        woocommerce_wp_text_input( $no_of_tickets );               
        woocommerce_wp_select( $raffle_type );
    }

    private function drp_GetDuplicatedMessage(){
        $health_obj =  $this->db_obj->runHealthCheck();
        $result = array();
        if( $health_obj == null )
            return $result;
        else{
          
            foreach( $health_obj as $dup ){
                $raffle_name = $dup->r_name;
                if( $dup->catid_one == '0')
                    $raffle_name = $this->get_raffle_name();

                $line = "<p>" . sprintf( esc_html('%s- Order Id %d has ticket number %d', 
                RAFFLE_PLAY_WOO_DOMAIN), $raffle_name, $dup->order_id, $dup->ticket ) . "</p>";
                array_push( $result, $line ); 
            }
                     
        }

        return $result;
    }

    public function drp_settings(){   
       
        if( is_user_logged_in() && current_user_can( 'manage_options' ) && is_admin() ){
        
            $settings = $this->drp_get_main_settings();
            $settings['health'] = $this->drp_GetDuplicatedMessage();         

            drp_MainPage( $settings );
        }
    }

    public function drp_view_page(){
        $settings = array(
            'live_raffle' => $this->isLiveRaffle(),
            'statuses' => wc_get_order_statuses(),         
            'saved_statuses' => explode( ',', $this->getFilterStatusView() ),
            'raffles' => $this->get_simple_raffles(),                    
        );
       
        drp_ViewPage( $settings );
    }

    public function drp_audit_page(){
        $settings = array();
        drp_AuditPage( $settings );
    }


    public function drp_reports_page(){

        if( is_user_logged_in() && current_user_can( 'manage_options' ) && is_admin() ){            

            $countries_obj   = new WC_Countries();
            $countries       = $countries_obj->__get('countries');            

            $settings = array(
                'statuses' => wc_get_order_statuses(),
                'saved_statuses' => explode( ',', $this->getOption('saved_statuses', 'wc-processing,wc-completed') ),
                'custom_currency' => $this->getOption('custom_currency', ''),
                'custom_cols'    =>  stripslashes( $this->getOption('custom_cols', '[]') ),
                'custom_cols_ava' => stripslashes( $this->getOption('custom_cols_ava', '[]') ), 
                'countries'      => $countries,
                'base_country'   => $countries_obj->get_base_country(),
                'raffles'        => $this->get_simple_raffles(),                          
            );

            RafflePlayWoo_Front::drp_reports_html( $settings );
        } 
    }

    public function drp_save_settings(){
        //make sure user is logged in, and is administrator
        if( is_user_logged_in() && current_user_can( 'manage_options' ) && is_admin() ){
            if( isset( $_POST['data'] ) && isset( $_POST['action']) && ($_POST['action'] === 'drp_save_settings') ){
                
                $init_count_start_at = isset( $_POST['data'][ self::COUNT_STARTS_AT_TXT ] ) ? sanitize_text_field( $_POST['data'][ self::COUNT_STARTS_AT_TXT ] ) : '';
                $init_live_raffle    = '1'; 
                $email_header        = isset( $_POST['data'][ self::EMAIL_HEADER ] ) ? sanitize_text_field( $_POST['data'][ self::EMAIL_HEADER  ] ) : '';
                $email_body          = isset( $_POST['data'][ self::EMAIL_BODY ] ) ? sanitize_text_field( $_POST['data'][ self::EMAIL_BODY  ] ) : '';
                $ticket_prefix       = isset( $_POST['data'][ self::TICKET_PREFIX ] ) ? sanitize_text_field( $_POST['data'][ self::TICKET_PREFIX  ] ) : '';  

                $email_pos           = '2'; 
                $is_terminated       = 'no';                
              
                $raffle_name         = isset( $_POST['data'][ self::RAFFLE_NAME ] ) ? sanitize_text_field( $_POST['data'][ self::RAFFLE_NAME  ] ) : '';
                $inc_name            = isset( $_POST['data'][ self::INC_NAME ] ) ? sanitize_text_field( $_POST['data'][ self::INC_NAME  ] ) : '0';
                                 
                $this->updateRaffleLimited('no');

                $count_start_at  = intval( $init_count_start_at ) ;
                $old_count_at   =  intval( $this->getCountStartsAt() );
                $live_raffle_val = sanitize_text_field( $init_live_raffle );

                $this->set_raffle_name( $raffle_name );

                $this->setEmailPos( $email_pos );

                $this->setRaffleTerminated( $is_terminated );  
                               

                if( strlen( $ticket_prefix ) > 10 )
                    $ticket_prefix = substr( $ticket_prefix, 0, 10 );
                
                if( $count_start_at !== $old_count_at ){
                    
                    $this->updateCountStartsAt( $count_start_at );
                    $this->updateLastTicketNo( $count_start_at, true);
                }
                
                if( $live_raffle_val != '' )
                    $this->updateLiveRaffle( $live_raffle_val ); 
                  
                if(  isset( $_POST['data'][ self::EMAIL_HEADER ] ) )
                    $this->setEmailHeaderLbl( $email_header );
                
                if( isset( $_POST['data'][ self::EMAIL_BODY ] ) )
                    $this->setEmailBodyLbl( $email_body );

                if( isset( $_POST['data'][ self::TICKET_PREFIX ] ) )
                    $this->setTicketPrefix( $ticket_prefix );
                

                $return = [
                    'live_raffle' => $this->isLiveRaffle(),
                    'count_start_at' => $this->getCountStartsAt(),
                    'last_live_ticket' => $this->db_raffle->getLastSoldTicket( 0 ),
                    'email_header'   => $email_header,
                    'email_body'     => $email_body,                                       
                ];
                echo json_encode( $return );
                die();              
            }else{
                echo '0';
                die();
            }
        }else{
            echo '0';
            die();
        }

    }

    public function drp_get_data(){
        //make sure user is logged in, and is administrator
        if ( is_user_logged_in() && current_user_can( 'manage_options' ) && is_admin() ) {
            if( isset( $_POST['data'] ) ){
              
                if( isset( $_POST['data']['get_info'])  && ( ($_POST['data']['get_info'] =='filter_dates') || ($_POST['data']['get_info'] =='get_info') ) ){

                    $inc_deleted    = isset( $_POST['data']['inc_deleted']) ? (intval( $_POST['data']['inc_deleted'] ) == '1') : false; 
                    $liveData       = isset( $_POST['data']['live_data']) ? (intval( $_POST['data']['live_data'] ) == '1') : false; 
                    $fromDate       = isset( $_POST['data']['dates']['from_date'] )  ?  sanitize_text_field( $_POST['data']['dates']['from_date'] ) : '';
                    $toDate         = isset( $_POST['data']['dates']['to_date'] )  ?  sanitize_text_field( $_POST['data']['dates']['to_date'] ) : '';
                    $raffle_id      = isset( $_POST['data']['raffle']) ? intval( $_POST['data']['raffle'] )  : 0; 

                    $is_pending         = isset( $_POST['data']['is_pending'] ) ?   intval( $_POST['data']['is_pending'] ) : 0; 
                    $is_processing      = isset( $_POST['data']['is_processing'] ) ? intval( $_POST['data']['is_processing'] ) : 0; 
                    $is_on_hold         = isset( $_POST['data']['is_on_hold'] ) ? intval( $_POST['data']['is_on_hold'] ) : 0; 
                    $is_completed       = isset( $_POST['data']['is_completed'] ) ? intval( $_POST['data']['is_completed'] ) : 0; 
                    $is_cancelled       = isset( $_POST['data']['is_cancelled'] ) ? intval( $_POST['data']['is_cancelled'] ) : 0; 
                    $is_refunded        = isset( $_POST['data']['is_refunded'] ) ? intval( $_POST['data']['is_refunded'] ) : 0; 
                    $is_failed          = isset( $_POST['data']['is_failed'] ) ? intval( $_POST['data']['is_failed'] ) : 0;  
                    
                    $order_status = array();
                    if( $is_pending === 1 ) array_push( $order_status, "'wc-pending'");
                    if( $is_processing === 1 ) array_push( $order_status, "'wc-processing'"); 
                    if( $is_on_hold === 1 ) array_push( $order_status, "'wc-on-hold'"); 
                    if( $is_completed === 1 ) array_push( $order_status, "'wc-completed'"); 
                    if( $is_cancelled === 1 ) array_push( $order_status, "'wc-cancelled'"); 
                    if( $is_refunded === 1 ) array_push( $order_status, "'wc-refunded'"); 
                    if( $is_failed === 1 ) array_push( $order_status, "'wc-failed'"); 

             
                    
                    $extraSettings  = array(
                       'from_date' => $fromDate,
                       'to_date'   => $toDate,
                       'raffle_id' => $raffle_id,
                       'order_status' => implode(',', $order_status )
                    );
                 
                    $tickets_data   = $this->db_obj->getLiveData( $liveData, $extraSettings, $inc_deleted );
                    echo json_encode( $tickets_data );
                    die();

                }else if( isset( $_POST['data']['get_info']) && ($_POST['data']['get_info'] == 'get_order_link')){

                    if( isset( $_POST['data']['order_id'] ) ){

                        $order_id = intval( $_POST['data']['order_id'] );
                        $url_order = get_edit_post_link( $order_id );                    
                        echo urlencode( $url_order );
                        die();

                    }else{
                        echo '';
                        die();
                    }
                }else if ( isset( $_POST['data']['action_delete'] ) && ($_POST['data']['action_delete'] == 'drp_delete_tickets' )){
                    $raffle_id = intval( sanitize_text_field( $_POST['data']['raffle_id'] ) );

                    $result = $this->db_raffle->deleteAllTickets( $raffle_id );
                    echo $result;
                    die();
                }                
                else{
                    echo '0';
                    die();
                }    
            }else{
                echo '0';
                die();
            }
        }else{
            echo '0';
            die();
        }   
    }


    public function drp_fix_db(){
        if ( is_user_logged_in() && current_user_can( 'manage_options' ) && is_admin() ) {

            if( isset( $_POST['data']) && ( $_POST['data'] == 'fix_db') ){
                $this->setVersionSaved( rand( 155, 1000) );
                echo 'changed';
                die();

            }else{
                die();
            }

        }
    }

    public function drp_raffles_page(){

        if( is_user_logged_in() && current_user_can( 'manage_options' ) && is_admin() ){

            $settings = array();         

            drp_ProductPage( $settings );

        }
    }

    private function get_simple_raffles(){
        if( $this->default_raffle == null )
            $this->drp_loadDefaultRaffle( 0 );

        $default_raffle_name = $this->default_raffle->get_name();

        if( $this->default_raffle->is_terminated() )
            $default_raffle_name .= ' (' . __('Terminated', RAFFLE_PLAY_WOO_DOMAIN ) . ')';

        $options = array(        
            '0' => $default_raffle_name
        );
     
        $raffles = $this->db_raffle->rafflesAsArray( $options);

        return $raffles;
    }


    public function drp_winners_page(){
        if( is_user_logged_in() && current_user_can( 'manage_options' ) && is_admin() ){

            $settings = array(
            );

            drp_WinnersPage( $settings );
        }
    }


    public function drp_info_page(){

        if ( is_user_logged_in() && current_user_can( 'manage_options' ) && is_admin() ) {

            if ( ! isset( $_POST['nonce_field_form_license'] ) ||
                 ! wp_verify_nonce( $_POST['nonce_field_form_license'], 'nonce_field_form_license' ) ){
                  
              
            }else{
              
            }
           
            $settings = array();
            drp_InfoPage( $settings );
        }

    }

}